import { usePanGesture } from "./use-pan-gesture";
import { useTapGesture } from "./use-tap-gesture";
import { useHoverGesture } from "./use-hover-gesture";
/**
 * Add pan and tap gesture recognition to an element.
 *
 * @param props - Gesture event handlers
 * @param ref - React `ref` containing a DOM `Element`
 * @public
 */
export function useGestures(props, visualElement) {
    usePanGesture(props, visualElement);
    useTapGesture(props, visualElement);
    useHoverGesture(props, visualElement);
}
//# sourceMappingURL=use-gestures.js.map