import { isMouseEvent } from "./utils/event-type";
import { usePointerEvent } from "../events/use-pointer-event";
import { AnimationType } from "../render/VisualElement/utils/animation-state";
var filterTouch = function (listener) { return function (event, info) {
    if (isMouseEvent(event))
        listener(event, info);
}; };
/**
 *
 * @param props
 * @param ref
 * @internal
 */
export function useHoverGesture(_a, visualElement) {
    var onHoverStart = _a.onHoverStart, onHoverEnd = _a.onHoverEnd;
    usePointerEvent(visualElement, "pointerenter", filterTouch(function (event, info) {
        var _a;
        onHoverStart === null || onHoverStart === void 0 ? void 0 : onHoverStart(event, info);
        (_a = visualElement.animationState) === null || _a === void 0 ? void 0 : _a.setActive(AnimationType.Hover, true);
    }));
    usePointerEvent(visualElement, "pointerleave", filterTouch(function (event, info) {
        var _a;
        onHoverEnd === null || onHoverEnd === void 0 ? void 0 : onHoverEnd(event, info);
        (_a = visualElement.animationState) === null || _a === void 0 ? void 0 : _a.setActive(AnimationType.Hover, false);
    }));
}
//# sourceMappingURL=use-hover-gesture.js.map