/**
 * Components
 */
export { motion, createDomMotionComponent } from "./render/dom";
export { m } from "./render/dom/minimal-component";
export { AnimatePresence } from "./components/AnimatePresence";
export { AnimateSharedLayout } from "./components/AnimateSharedLayout";
export { HTMLVisualElement } from "./render/dom/HTMLVisualElement";
/**
 * Features
 */
export { Animation as AnimationFeature } from "./motion/features/animation";
export { Drag as DragFeature } from "./motion/features/drag";
export { Exit as ExitFeature } from "./motion/features/exit";
export { Gestures as GesturesFeature } from "./motion/features/gestures";
export { AnimateLayout as AnimateLayoutFeature } from "./motion/features/layout/Animate";
/**
 * Motion values
 */
export { useMotionValue } from "./value/use-motion-value";
export { useMotionTemplate } from "./value/use-motion-template";
export { MotionValue, motionValue } from "./value";
export { resolveMotionValue } from "./value/utils/resolve-motion-value";
export { useTransform } from "./value/use-transform";
export { useSpring } from "./value/use-spring";
export { useElementScroll } from "./value/scroll/use-element-scroll";
export { useViewportScroll } from "./value/scroll/use-viewport-scroll";
/**
 * Accessibility
 */
export { useReducedMotion } from "./utils/use-reduced-motion";
/**
 * Utils
 */
export { AnimationControls, animationControls, } from "./animation/AnimationControls";
export { useAnimation } from "./animation/use-animation";
export { animate } from "./animation/animate";
export { animateVisualElement } from "./render/VisualElement/utils/animation";
export { useTapGesture, usePanGesture, useGestures, } from "./gestures";
export { useCycle } from "./utils/use-cycle";
export { transform } from "./utils/transform";
export { isValidMotionProp } from "./motion/utils/valid-prop";
export { usePresence, useIsPresent, } from "./components/AnimatePresence/use-presence";
export { useDragControls, DragControls, } from "./gestures/drag/use-drag-controls";
export { useDomEvent } from "./events/use-dom-event";
export { useExternalRef } from "./motion/utils/use-external-ref";
export { createMotionComponent } from "./motion";
export { addScaleCorrection } from "./render/dom/layout/scale-correction";
/**
 * Contexts
 */
export { MotionConfig, MotionConfigContext, } from "./motion/context/MotionConfigContext";
export { PresenceContext } from "./components/AnimatePresence/PresenceContext";
export { LayoutGroupContext } from "./components/AnimateSharedLayout/LayoutGroupContext";
export { VisibilityAction, } from "./components/AnimateSharedLayout/types";
export { SharedLayoutContext, FramerTreeLayoutContext, createBatcher, } from "./components/AnimateSharedLayout/SharedLayoutContext";
export * from "./types/geometry";
//# sourceMappingURL=index.js.map