import { useContext } from "react";
import { SharedLayoutContext, FramerTreeLayoutContext, isSharedLayout, } from "../../../components/AnimateSharedLayout/SharedLayoutContext";
import { useIsomorphicLayoutEffect } from "../../../utils/use-isomorphic-effect";
export function useSnapshotOnUnmount(visualElement) {
    var syncLayout = useContext(SharedLayoutContext);
    var framerSyncLayout = useContext(FramerTreeLayoutContext);
    useIsomorphicLayoutEffect(function () { return function () {
        if (isSharedLayout(syncLayout)) {
            syncLayout.remove(visualElement);
        }
        if (isSharedLayout(framerSyncLayout)) {
            framerSyncLayout.remove(visualElement);
        }
    }; }, []);
}
//# sourceMappingURL=use-snapshot-on-unmount.js.map